/*
 * CGKey.cpp
 *
 *  Created on: Oct 24, 2012
 *      Author: ixert
 */

#include "CGKey.h"
#include <iostream>

using namespace std;

CGKey::CGKey(){
}
CGKey::CGKey(vector<mpq_class> const &jVal, vector<mpq_class> const &jjVal):j(jVal),jj(jjVal){
}
CGKey::CGKey(mpq_class const &jVal, mpq_class const &jjVal){
	j.push_back(jVal);
	jj.push_back(jjVal);
}

void CGKey::setJ(vector<mpq_class> const &jVal){
	j=jVal;
}
void CGKey::setJJ(vector<mpq_class> const &jjVal){
	jj=jjVal;
}
void CGKey::addJ(mpq_class const &jVal){
	j.push_back(jVal);
}
void CGKey::addJJ(mpq_class const &jjVal){
	jj.push_back(jjVal);
}
vector<mpq_class> CGKey::getJ() const{
	return j;
}
vector<mpq_class> CGKey::getJJ() const{
	return jj;
}
mpq_class CGKey::getJ(unsigned int const &i) const{
	return j[i];
}
mpq_class CGKey::getJJ(unsigned int const &i) const{
	return jj[i];
}

unsigned int CGKey::getJSize() const{
	return j.size();
}
unsigned int CGKey::getJJSize() const{
	return jj.size();
}

bool operator==(CGKey const& lhs, CGKey const& rhs){
	bool isEqual=true;
	if(lhs.j!=rhs.j){
		isEqual=false;
	}
	if(lhs.jj!=rhs.jj){
		isEqual=false;
	}
	return isEqual;
}

bool operator!=(CGKey const& lhs, CGKey const& rhs){
	return !(lhs==rhs);
}

bool operator<(CGKey const& lhs, CGKey const& rhs){
	return (lhs.j<rhs.j) || (lhs.jj<rhs.jj);
}
