/*
 * CGKey.h
 *
 *  Created on: Oct 24, 2012
 *      Author: ixert
 */

#ifndef CGKEY_H_
#define CGKEY_H_

#include <vector>
#include <gmp.h>
#include <gmpxx.h>

using namespace std;

class CGKey {
friend bool operator==(CGKey const& lhs, CGKey const& rhs);
friend bool operator<(CGKey const& lhs, CGKey const& rhs);
private:
	vector<mpq_class> j;
	vector<mpq_class> jj;
public:
	CGKey();
	CGKey(vector<mpq_class> const &jVal, vector<mpq_class> const &jjVal);
	CGKey(mpq_class const &jVal, mpq_class const &jjVal);

	void setJ(vector<mpq_class> const &jVal);
	void setJJ(vector<mpq_class> const &jjVal);
	void addJ(mpq_class const &jVal);
	void addJJ(mpq_class const &jjVal);
	vector<mpq_class> getJ() const;
	vector<mpq_class> getJJ() const;
	mpq_class getJ(unsigned int const &i) const;
	mpq_class getJJ(unsigned int const &i) const;

	unsigned int getJSize() const;
	unsigned int getJJSize() const;
};

bool operator==(CGKey const& lhs, CGKey const& rhs);
bool operator!=(CGKey const& lhs, CGKey const& rhs);
bool operator<(CGKey const& lhs, CGKey const& rhs);

#endif /* CGKEY_H_ */
