/*
 * eigen_sym.h
 *
 *  Created on: Jul 27, 2012
 *      Author: ixert
 */

#ifndef EIGEN_SYM_H_
#define EIGEN_SYM_H_

#include "numericLimits.h"
#include "nr3.h"

void eigsrt(VecDoub_IO &d, MatDoub_IO *v=NULL);

struct Jacobi {
	const Int n;
	MatDoub a,v;
	VecDoub d;
	Int nrot;
	const Doub EPS;

	Jacobi(MatDoub_I &aa);

	inline void rot(MatDoub_IO &a, const Doub s, const Doub tau, const Int i,
		const Int j, const Int k, const Int l)
	{
		Doub g=a[i][j];
		Doub h=a[k][l];
		a[i][j]=g-s*(h+g*tau);
		a[k][l]=h+s*(g-h*tau);
	}
};
struct Symmeig {
	Int n;
	MatDoub z;
	VecDoub d,e;
	Bool yesvecs;

	Symmeig(MatDoub_I &a, Bool yesvec=true);
	Symmeig(VecDoub_I &dd, VecDoub_I &ee, Bool yesvec=true);
	void sort();
	void tred2();
	void tqli();
	Doub pythag(const Doub a, const Doub b);
};

#endif /* EIGEN_SYM_H_ */
