/*
 * functions.cpp
 *
 *  Created on: 10.11.2011
 *      Author: ixert
 */

#include "functions.h"

bool testNRSolution(MatDoub const &A, VecDoub const &x, VecDoub const &b){
	Doub tempVar=0;
	bool solution=true;
	unsigned int n=A.nrows();
	unsigned int m=A.ncols();
	for(unsigned int i=0;i<n;i++){
		tempVar=0;
		for(unsigned int j=0;j<m;j++){
			tempVar+=A[i][j]*x[j];
		}
		tempVar-=b[i];
		cout << tempVar << "\n";
		if(fabs(tempVar)>zeroGlsEPS){
			solution=false;
		}
	}
	return solution;
}

void invertSorting(VecDoub &eval, MatDoub &evec){
	unsigned int n=eval.size();
	VecDoub eval2(n);
	MatDoub evec2(n,n);
	for(unsigned int i=0;i<n;i++){
		eval2[i]=eval[n-1-i];
		for(unsigned int j=0;j<n;j++){
			evec2[j][i]=evec[j][n-1-i];
		}
	}
	eval=eval2;
	evec=evec2;
}
void sortEigenvaluesAndStates(VecDoub &eval, vector<StateDouble> &vs){
	unsigned int n=eval.size();
	for(unsigned int i=0;i<n;i++){
		unsigned int iMin=i;
		for(unsigned int j=i+1;j<n;j++){
			if(eval[j]<eval[iMin]){
				iMin=j;
			}
		}
		Doub temp=eval[i];
		eval[i]=eval[iMin];
		eval[iMin]=temp;
		StateDouble tempState=vs[i];
		vs[i]=vs[iMin];
		vs[iMin]=tempState;
	}
}

void printProcessingTime(time_t startingTime){
    time_t processingTime = time(NULL) - startingTime;
	time_t hours = processingTime / 3600;
	time_t minutes = processingTime / 60 - 60 * hours;
	time_t seconds = processingTime - hours * 3600 - minutes * 60;
	cout << hours << " hours, " << minutes << " minutes and " << seconds << " seconds.\n";
}

vector<unsigned int> createPosNot(unsigned int const &n, vector<unsigned int> const &pos){
	vector<unsigned int> posNot(n);
	for(unsigned int i=0;i<n;i++){
		posNot[i]=i;
	}
	for(unsigned int i=0;i<pos.size();i++){
		unsigned int j=0;
		while(j<posNot.size()){
			if(posNot[j]==pos[i]){
				posNot.erase(posNot.begin()+j);
			}
			else{
				j++;
			}
		}
	}
	return posNot;
}
