/*
 * functors.h
 *
 *  Created on: Jul 12, 2012
 *      Author: ixert
 */

#ifndef FUNCTORS_H_
#define FUNCTORS_H_

#include "globalVariables.h"
#include "nr3.h"
using namespace std;

struct funcQP {
	unsigned int basisSize; //size of array
	vector<unsigned int> q; //QP-Numbers
    unsigned int unitary; //should be 0 if U should not calculated and 1 otherwise
	funcQP(unsigned int basisSizeI, vector<unsigned int> qI, unsigned int unitaryI);
	void operator()(const Doub x, VecDoub_I &y, VecDoub_O &dydx);
	Doub offBlockDiagonalElements(VecDoub_I &y);
};

struct funcWegner {
	unsigned int basisSize;
	unsigned int llsSize;
	unsigned int unitary; //should be 0 if U should not calculated and 1 otherwise
	funcWegner(unsigned int basisSizeI, unsigned int llsSizeI, unsigned int unitaryI);
	void operator()(const Doub x, VecDoub_I &y, VecDoub_O &dydx);
	Doub offBlockDiagonalElements(VecDoub_I &y);
};

#endif /* FUNCTORS_H_ */
