#include "mathFunctions.h"
#include <math.h>
#include <algorithm>

using namespace std;


double myAbs(double const &x){
	return fabs(x);
}

unsigned int faculty(unsigned int const &x){
	unsigned int y=1;
	for(unsigned int i=2;i<=x;i++){
		y*=i;
	}
	return y;
}

Doub calculateClebschGordanCoefficient(mpq_class j1,mpq_class j2,mpq_class J,mpq_class m1,mpq_class m2,mpq_class M){
	Doub CG=0;
	if(M==m1+m2){
		vector<mpq_class> kMinVector;
		kMinVector.push_back(0);
		kMinVector.push_back(-J+j1+m2);
		kMinVector.push_back(-J+j2-m1);
		vector<mpq_class> kMaxVector;
		kMaxVector.push_back(j1-m1);
		kMaxVector.push_back(j2+m2);
		mpq_class kMin=*max_element(kMinVector.begin(),kMinVector.end());
		mpq_class kMax=*min_element(kMaxVector.begin(),kMaxVector.end());
		//cout << "kMin=" << kMin << " kMax=" << kMax << "\n";
		for(unsigned int k=static_cast<unsigned int>(kMin.get_d());k<=static_cast<unsigned int>(kMax.get_d());k++){
			Doub x=pow(Doub(-1),int(k));
			x/=faculty(k);
			mpq_class mpqTemp=j1+j2-J-mpq_class(k,1);
			if(mpqTemp>=0){
				x/=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
			}
			else{
				break;
			}
			mpqTemp=j1-m1-mpq_class(k,1);
			if(mpqTemp>=0){
				x/=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
			}
			else{
				break;
			}
			mpqTemp=j2+m2-mpq_class(k,1);
			if(mpqTemp>=0){
				x/=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
			}
			else{
				break;
			}
			mpqTemp=J-j2+m1+mpq_class(k,1);
			if(mpqTemp>=0){
				x/=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
			}
			else{
				break;
			}
			mpqTemp=J-j1-m2+mpq_class(k,1);
			if(mpqTemp>=0){
				x/=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
			}
			else{
				break;
			}
			CG+=x;
		}
		Doub y=1;
		mpq_class mpqTemp=J+j1+j2+mpq_class(1,1);
		y/=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
		mpqTemp=-J+j1+j2;
		y*=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
		mpqTemp=J+j1-j2;
		y*=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
		mpqTemp=J-j1+j2;
		y*=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
		mpqTemp=mpq_class(2,1)*J+mpq_class(1,1);
		y*=static_cast<unsigned int>(mpqTemp.get_d());
		mpqTemp=j1+m1;
		y*=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
		mpqTemp=j1-m1;
		y*=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
		mpqTemp=j2+m2;
		y*=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
		mpqTemp=j2-m2;
		y*=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
		mpqTemp=J+M;
		y*=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
		mpqTemp=J-M;
		y*=faculty(static_cast<unsigned int>(mpqTemp.get_d()));
		CG*=sqrt(y);
	}
	return CG;
}

Doub calculateGeneralClebschGordanCoefficient(vector<mpq_class> vj, vector<mpq_class> vm){
	Doub CG=0;
	unsigned int vjSize=vj.size();
	unsigned int vmSize=vm.size();
	if((vjSize==3) && (vmSize==3)){
		CG=calculateClebschGordanCoefficient(vj[0],vj[1],vj[2],vm[0],vm[1],vm[2]);
	}
	else{
		vector<mpq_class> vj2;
		for(unsigned int i=0;i<=vjSize-3;i++){
			vj2.push_back(vj[i]);
		}
		vector<mpq_class> vm2;
		for(unsigned int i=0;i<vmSize-3;i++){
			vm2.push_back(vm[i]);
		}
		for(mpq_class mRun=-vj[vjSize-3];mRun<=vj[vjSize-3];mRun+=mpq_class(1,1)){
			vector<mpq_class> vm3=vm2;
			vm3.push_back(mRun);
			Doub CGTemp=calculateGeneralClebschGordanCoefficient(vj2,vm3);
			if(fabs(CGTemp)>zeroEPS){
				CG+=CGTemp*calculateClebschGordanCoefficient(vj[vjSize-3],vj[vjSize-2],vj[vjSize-1],mRun,vm[vmSize-2],vm[vmSize-1]);
			}
		}
	}
	return CG;
}
