// general mathematical functions

#ifndef MATHFUNCTIONS_H_
#define MATHFUNCTIONS_H_

#include "globalVariables.h"
#include <gmp.h>
#include <gmpxx.h>

template<class T>
int sgn(T x){
	if(x>0){
		return 1;
	}
	else{
		if(x<0){
			return -1;
		}
		else{
			return 0;
		}
	}
}

template<class T>
void setArrayToZero(int n, T* x){
	for(int i=0;i<n;i++){
		x[i]=0;
	}
}

double myAbs(double const &x);
unsigned int faculty(unsigned int const &x);

Doub calculateClebschGordanCoefficient(mpq_class j1,mpq_class j2,mpq_class J,mpq_class m1,mpq_class m2,mpq_class M);
Doub calculateGeneralClebschGordanCoefficient(vector<mpq_class> vj, vector<mpq_class> vm);

#endif /* MATHFUNCTIONS_H_ */
