/*
 * svd.h
 *
 *  Created on: Jul 27, 2012
 *      Author: ixert
 */

#ifndef SVD_H_
#define SVD_H_

#include "nr3.h"

struct SVD {
	Int m,n;
	MatDoub u,v;
	VecDoub w;
	Doub eps, tsh;
	SVD(MatDoub_I &a);

	void solve(VecDoub_I &b, VecDoub_O &x, Doub thresh = -1.);
	void solve(MatDoub_I &b, MatDoub_O &x, Doub thresh = -1.);

	Int rank(Doub thresh = -1.);
	Int nullity(Doub thresh);
	MatDoub range(Doub thresh);
	MatDoub nullspace(Doub thresh);

	Doub inv_condition();

	void decompose();
	void reorder();
	Doub pythag(const Doub a, const Doub b);
};
#endif /* SVD_H_ */
