/*
 * GraphController.h
 *
 *  Created on: Jul 1, 2014
 *      Author: ixert
 */

#ifndef GRAPHCONTROLLER_H_
#define GRAPHCONTROLLER_H_

#include<string>
#include<vector>
#include<map>

using namespace std;

class GraphController {
private:
	vector<vector<int> > latticeVectors;
	//vector<unsigned int> coordinationNumberByCoupling;
	map<char,vector<unsigned int> > coordinationNumberByCouplingForSiteTypes;
public:
	GraphController(string const &sInverseCouplingsFile, string const &sLatticeFile);

	void createGraphs(unsigned int const &gCUTOrder, bool const &pCUTGraphs, string const &sMasterCluster, string const &sInitialSiteList);
	void calculateGraphSubtractions(unsigned int const &gCUTOrder, string const &sGraphList);
	void calculateGraphEmbeddings(unsigned int const &gCUTOrder, string const &sGraphList, string const &sMasterCluster, string const &sInitialSiteList);

	void createMasterCluster(unsigned int const &xMax, unsigned int const &yMax, unsigned int const &n, string const &sMasterCluster, string const &sGnuplot, string const &sPlotPoints);

	void createEDCluster(unsigned int const &gCUTOrder, string const &sInterUnitCellVectors, string const &sIntraUnitCellVectors, unsigned int const &v1Max, unsigned int const &v2Max, string const &sSpinModelTDLFull);

	void createEDClusterInDifferentUCBasis(unsigned int const &gCUTOrder, string const &sInterUnitCellVectorsOld, string const &sIntraUnitCellVectorsOld, string const &sInterUnitCellVectors, string const &sIntraUnitCellVectors, unsigned int const &v1Max, unsigned int const &v2Max, string const &sSpinModelTDLFull, string const &sReplaceCouplings);

	void createEDClusterForGeneralClusterForm(unsigned int const &gCUTOrder, string const &sInterUnitCellVectorsOld, string const &sIntraUnitCellVectorsOld, string const &sSiteBoundariesFile, string const &sPeriodicBoundariesFile, string const &sSpinModelTDLFull, string const &sReplaceCouplings, string const &sClusterName);

	void createHubbardEDCluster(string const &sInterUnitCellVectors, string const &sIntraUnitCellVectors, unsigned int const &v1Max, unsigned int const &v2Max);

	void performGraphSubtractionsAndEmbeddings(unsigned int const &gCUTOrder, string const &sGraphList, string const &sInitialSiteList, string const &sSubtractionList, string const &sSpinModelFormList, string const &sEffSpinModelList, string const &sMasterClusterLg);

	void createSiteCombinationsWithEdgeSpins(unsigned int const &gCUTOrder, string const &sGraphList, string const &sMasterCluster, string const &sInitialSiteList);
};

#endif /* GRAPHCONTROLLER_H_ */
