/*
 * pairFunctions.h
 *
 *  Created on: Mar 21, 2016
 *      Author: ixert
 */

#ifndef PAIRFUNCTIONS_H_
#define PAIRFUNCTIONS_H_

#include<utility>
#include<iostream>

using namespace std;

template<class S,class T>
istream& operator>>(istream &o, pair<S,T> &s){
	char tempchar;
	bool setFailbit=false;
	if(o.peek()=='('){
		o>>tempchar;
		if(o>>s.first){
			if(o.peek()==','){
				o>>tempchar;
				if(o>>s.second){
					if(o.peek()==')'){
						o>>tempchar;
					}
					else{
						setFailbit=true;
					}
				}
			}
			else{
				setFailbit=true;
			}
		}
	}
	else{
		setFailbit=true;
	}
	if(setFailbit){
		//cout << "set failbit!\n";
		o.setstate(ios_base::failbit);
	}

	return o;
}

template<class S,class T>
ostream& operator<<(ostream &o, pair<S,T> const &s){
	o << "(" << s.first << "," << s.second << ")";

	return o;
}

template<class S,class T>
pair<S,T>& operator*=(pair<S,T> &p1,pair<S,T> const &p2){
	p1.first=p1.first*p2.first-p1.second*p2.second;
	p1.second=p1.first*p2.second+p1.second*p2.first;
	return p1;
}
template<class S,class T>
pair<S,T>& operator*=(pair<S,T> &p2,int const &x){
	p2.first*=x;
	p2.second*=x;
	return p2;
}

template<class S,class T>
pair<S,T> operator*(pair<S,T> const &p1,pair<S,T> const &p2){
	pair<S,T> p=p1;
	p*=p2;
	return p;
}

template<class S,class T>
pair<S,T>& operator+=(pair<S,T> &p1,pair<S,T> const &p2){
	p1.first+=p2.first;
	p1.second+=p2.second;
	return p1;
}



#endif /* PAIRFUNCTIONS_H_ */
