/*
 * functions.cpp
 *
 *  Created on: 10.11.2011
 *      Author: ixert
 */

#include "functions.h"
#include <iostream>
using namespace std;

void printProcessingTime(time_t startingTime){
    time_t processingTime = time(NULL) - startingTime;
	time_t hours = processingTime / 3600;
	time_t minutes = processingTime / 60 - 60 * hours;
	time_t seconds = processingTime - hours * 3600 - minutes * 60;
	cout << hours << " hours, " << minutes << " minutes and " << seconds << " seconds.\n";
}

mpz_class pow(mpz_class const &a,unsigned int const &b){
	mpz_class c=1;
	for(unsigned int i=1;i<=b;i++){
		c*=a;
	}
	return c;
}

void calculateAllPermutations(vector<unsigned short> const &allSites, vector<vector<unsigned short> > &allPermutations1){
	// calculates all permutations of allSites and stores them in allPermutations1
	allPermutations1.clear();

	vector<unsigned short> vTemp;
	allPermutations1.push_back(vTemp);
	for(unsigned i=0;i<allSites.size();i++){
		vector<vector<unsigned short> > allPermutations2;
		for(unsigned int j=0;j<allSites.size();j++){
			for(unsigned int k=0;k<allPermutations1.size();k++){
				// check if allSites[j] exists already in allPermutations1[k]
				bool existsAlready=false;
				for(unsigned int m=0;m<allPermutations1[k].size();m++){
					if(allPermutations1[k][m]==allSites[j]){
						existsAlready=true;
						break;
					}
				}
				if(!existsAlready){
					vTemp=allPermutations1[k];
					vTemp.push_back(allSites[j]);
					allPermutations2.push_back(vTemp);
				}
			}
		}
		allPermutations1.swap(allPermutations2);
	}
}

bool vectorLeq(vector<unsigned int> const &v1, vector<unsigned int> const &v2){
	// this function compares if vector v1 is less than v2
	// that means if EACH ELEMENT OF v1 is smaller than the corresponding element in v2
	if(v1.size()!=v2.size()){
		return false;
	}
	for(unsigned int i=0;i<v1.size();i++){
		if(v1[i]>v2[i]){
			return false;
		}
	}
	return true;
}
