/*
 * SpinDerivatorController.h
 *
 *  Created on: Feb 3, 2014
 *      Author: ixert
 */

#ifndef SPINDERIVATORCONTROLLER_H_
#define SPINDERIVATORCONTROLLER_H_

#include<gmpxx.h>
#include<gmp.h>

#include "SpinStateTemplate.h"
#include "nr3.h"
#include <map>

using namespace std;

class SpinDerivatorController {
private:
	unsigned int N;

	vector<SpinState> inputStates;
	vector<SpinStateTemplate<Doub> > inputStatesComplex; // hier nutzt er Double! habe den dateinamen einfach nicht umbenannt
	vector<SpinState> outputStates;

	list<list<pair<unsigned int,unsigned int> > > permutationOperators;
	list<SeriesDouble> effCouplings;

public:
	SpinDerivatorController(unsigned int const &Nvalue, string &sStates);

	bool calculateEffSpinModel();

	void saveEffSpinModel(string &sSpinModel);
};

#endif /* SPINDERIVATORCONTROLLER_H_ */
