/*
 * SpinStateTemplate.h
 *
 *  Created on: Feb 4, 2013
 *      Author: ixert
 */

#ifndef SPINSTATETEMPLATE_H_
#define SPINSTATETEMPLATE_H_

#include "StateTemplateSimple.h"

template<class T>
class SpinStateTemplate : public StateTemplateSimple<T> {
public:
	SpinStateTemplate();
	SpinStateTemplate(unsigned int nVal);
	SpinStateTemplate(vector<bool> &v);

	unsigned int size() const;

	SpinStateTemplate<T> applyPermutationOperators(list<pair<unsigned int,unsigned int> > const &operatorSequence) const;

	//SpinStateTemplate<T> convertToSpinState() const;
};

//// implementation ////
//// class functions ////

template<class T>
SpinStateTemplate<T>::SpinStateTemplate() : StateTemplateSimple<T>(){
}

template<class T>
SpinStateTemplate<T>::SpinStateTemplate(unsigned int nVal) : StateTemplateSimple<T>(nVal){
}

template<class T>
SpinStateTemplate<T>::SpinStateTemplate(vector<bool> &v) : StateTemplateSimple<T>(v){
}

template<class T>
unsigned int SpinStateTemplate<T>::size() const{
	return this->n;
}

template<class T>
SpinStateTemplate<T> SpinStateTemplate<T>::applyPermutationOperators(list<pair<unsigned int,unsigned int> > const &operatorSequence) const{
	SpinStateTemplate<T> s(this->n);
	vector<bool> v;
	bool tempBool;
	cout << "spinPerBitSite=" << StateTemplateSimple<T>::spinBitsPerSite << "\n";
	typename std::map<vector<bool>,T>::const_iterator it;
	for(it=this->stateCont.begin();it!=this->stateCont.end();it++){
		v=it->first;
		list<pair<unsigned int,unsigned int> >::const_iterator itList;
		for(itList=operatorSequence.begin();itList!=operatorSequence.end();++itList){
			unsigned int site1=itList->first;
			unsigned int site2=itList->second;
			for(unsigned int i=0;i<StateTemplateSimple<T>::spinBitsPerSite;i++){
				tempBool=v[StateTemplateSimple<T>::spinBitsPerSite*site1+i];
				v[StateTemplateSimple<T>::spinBitsPerSite*site1+i]=v[StateTemplateSimple<T>::spinBitsPerSite*site2+i];
				v[StateTemplateSimple<T>::spinBitsPerSite*site2+i]=tempBool;
			}
		}
		s.stateCont.insert(pair<vector<bool>,T>(v,it->second));
	}
	return s;
}


typedef SpinStateTemplate<SeriesTemplate<Doub,ExponentsTemplate<int> > > SpinState;

#endif /* SPINSTATETEMPLATE_H_ */
