#include<sstream>
#include<iostream>
#include<stdlib.h>

#include "nr3.h"
#include "SpinDerivatorController.h"


using namespace std;

int main(int argc, char *argv[]) {

	// output of globalVariables
	cout << "The solution of the linear equation system is considered true if A*x-b<"<< zeroGlsEPS << "\n";

	unsigned int N=0;
	string sStates("");
	string sSpinModel("");


	if(argc!=4){
		cout << "wrong number of arguments!\n";
		return 1;
	}
	stringstream ssN(argv[1]);
	ssN>>N;
	stringstream ssStates(argv[2]);
	sStates=ssStates.str();
	stringstream ssSpinModel(argv[3]);
	sSpinModel=ssSpinModel.str();

	SpinDerivatorController SDC(N,sStates);
	bool spinModelDerived=SDC.calculateEffSpinModel();

	if(!spinModelDerived){
		return 1;
	}

	SDC.saveEffSpinModel(sSpinModel);

	return 0;
}


