#include "mathFunctions.h"
#include <math.h>
#include <complex>
#include "SeriesTemplate.h"

using namespace std;

unsigned int faculty(unsigned int const &x){
	unsigned int y=1;
	for(unsigned int i=2;i<=x;i++){
		y*=i;
	}
	return y;
}

mpq_class pow(mpq_class const &x, int const &n){
	mpq_class ret(1);
	for(int i=0;i<n;i++){
		ret*=x;
	}
	return ret;
}


Doub myAbs(SeriesTemplate<Complex,ExponentsTemplate<int> > const &x){
	SeriesTemplate<Doub,ExponentsTemplate<int> > realSeries=x.real();
	SeriesTemplate<Doub,ExponentsTemplate<int> > imagSeries=x.imag();
	return sqrt((realSeries.getMaxAmplitude()*realSeries.getMaxAmplitude())+(imagSeries.getMaxAmplitude()*imagSeries.getMaxAmplitude()));
}
Doub myAbs(SeriesTemplate<mpq_class,ExponentsTemplate<int> > const &x){
	mpq_class xx=x.getMaxAmplitude();
	return abs(xx.get_d());
}

Doub myAbs(SeriesTemplate<Doub,ExponentsTemplate<int> > const &x){
	return abs(x.getMaxAmplitude());
}

Doub myAbs(Complex const &x){
	return abs(x);
}


Doub conj(Doub const &x){
	return x;
}

