/*
 * StaticBaseStateIO.h
 *
 *  Created on: 02.05.2011
 *      Author: klagges
 */

#ifndef BASESTATEIO_H_
#define BASESTATEIO_H_

#include <Framework/Solver.h>

/** Stream out as a string like |01011001>*/
template<typename T, unsigned int n> std::ostream& operator<<(std::ostream& o,
		const BaseStateTemplate<T, n>& b) {

	o << "|";

	for (unsigned int i = 0; i < solver.globalProperties.bitsPerBaseState; i++) {
		if (b.get(i))
			o << "1";
		else
			o << "0";
	}
	o << ">";
	return o;

}

/** Stream in from a string like |0101 0011>*/
template<typename T, unsigned int n> std::istream& operator>>(std::istream& i,
		BaseStateTemplate<T, n>& b) {

	std::string s;

	while (i.good()) {

		char peek = i.get();

		if (peek == '>' || peek == EOF)
			break;

		if (peek == '0' || peek == '1')
			s.push_back(peek);

	}

	b.clear();

	unsigned int counter = 0;

	for (std::string::const_iterator stringIt = s.begin(); stringIt != s.end(); stringIt++) {

		switch (*stringIt) {

		case '0':
			counter++;
			break;
		case '1':
			b.set(counter);
			counter++;
			break;

		}

	}

	return i;

}

#endif /* BASESTATEIO_H_ */
