/*
 * GlobalProperties.h
 *
 *  Created on: 21.09.2011
 *      Author: klagges
 */

#ifndef GLOBALPROPERTIES_H_
#define GLOBALPROPERTIES_H_

#include <Utilities/ParameterSet.h>

/** Class to store properties of the system dependent of both the model and the lattice.
 * Are calculated by the Solver::run method of the ::solver object.*/
class GlobalProperties {

public:

	/** The number of bits per base state.
	 * Should be ModelProperties::bitsPerLatticeSite * LatticeProperties::numberOfLatticeSites + LatticeProperties::numberOfExtraBits . */
	unsigned int bitsPerBaseState;

	/** The eigen energy of the \f$ H_0 \f$ eigen space in question.
	 * Calculated by the run method as:
	 * modules.pointerToModelProvider->getH_0Eigenvalue(solver.inputStates.right.begin()->first);*/
	double eigenEnergy;

};

#endif /* GLOBALPROPERTIES_H_ */
