/*
 * LatticeProperties.cpp
 *
 *  Created on: 21.09.2011
 *      Author: klagges
 */

#include <Interface/LatticeProperties.h>

void LatticeProperties::streamOutExample(std::ostream& stream) {

	stream << "# This is a BondList file.\n\n"
			<< "# The number of lattice sites.\n" << "4\n\n"
			<< "# The number of bits that should be reserved within a\n"
			<< "# BaseState object for storing extra information.\n" << "0\n\n"
			<< "# The file where to find the input states.\n"
			<< "InputStates.cfg\n\n" << "# Now the list of bonds.\n"
			<< "# Format:\n"
			<< "# PerturbationOperatorNumber LaticeSiteNumbers;\n"
			<< "# This example is a loop on four lattice sites.\n"
			<< "0  0 1;\n" << "0  1 2;\n" << "0  2 3;\n" << "0  3 0;\n";

}

void LatticeProperties::streamIn(std::istream& stream) {

	stream >> numberOfLatticeSites >> numberOfExtraBits;

	unsigned int index = 0;

	while (true) {

		Bond bond;
		stream >> bond;

		if (!stream.good())
			return;

		bond.index = index;

		index++;

		bonds.push_back(bond);

	}

}

std::ostream & operator <<(std::ostream & o, const LatticeProperties & d) {

	o << "Number of lattice site: " << d.numberOfLatticeSites << "\n";
	o << "Number of extra bits: " << d.numberOfExtraBits << "\n";
	o << "List of bonds (Index  OperatorNumber  ListOfSites; :\n";

	for (std::list<Bond>::const_iterator bondsIt = d.bonds.begin(); bondsIt
			!= d.bonds.end(); bondsIt++) {

		o << *bondsIt << "\n";

	}

	return o;

}

