/*
 * LatticeProperties.h
 *
 *  Created on: 21.09.2011
 *      Author: klagges
 */

#ifndef LATTICEPROPERTIES_H_
#define LATTICEPROPERTIES_H_

#include <Utilities/ParameterSet.h>
#include <Interface/Bond.h>

class LatticeProperties: public Utilities::ParameterSet {

public:

	void streamOutExample(std::ostream& stream);

	void streamIn(std::istream& stream);

	/** The number of lattice sites. */
	unsigned int numberOfLatticeSites;

	/** The number of bits that should be reserved for storing extra information
	 * within a BaseState object.*/
	unsigned int numberOfExtraBits;

	/** All bonds of the lattice as a list.*/
	std::list<Bond> bonds;

};

/** Stream out all lattice properties.*/
std::ostream& operator<<(std::ostream& o, const LatticeProperties& d);

#endif /* LATTICEPROPERTIES_H_ */
