/*
 * StatePair.cpp
 *
 *  Created on: 13.04.2011
 *      Author: klagges
 */

#include <Interface/StateIO.h>

void StatePair::streamOutExample(std::ostream& stream) {

	stream << "# State pairs are simply two states.\n\n"
			<< "# The left hand state (bra vector)\n" << "|0000>;\n\n"
			<< "# The right hand state (ket vector)\n" << "|1111>;\n";

}

void StatePair::streamIn(std::istream& stream) {

	stream >> left >> right;

	left.type = State::bra;
	right.type = State::ket;

}

std::ostream& operator<<(std::ostream& o, const StatePair& d) {

	o << d.left << d.right;

	return o;

}

