/*
 * StatePair.h
 *
 *  Created on: 13.04.2011
 *      Author: klagges
 */

#ifndef STATEPAIR_H_
#define STATEPAIR_H_

#include <Utilities/ParameterSet.h>
#include <Interface/Interface.h>

/** A class to represent a pair of State objects (a State::bra and a State::ket vector).
 * Used to represent the Solver::inputStates. Can be streamed in from files. */
class StatePair: public Utilities::ParameterSet {

public:

	void streamOutExample(std::ostream& stream);

	void streamIn(std::istream& stream);

	/** The left hand state (State::bra vector). */
	State left;

	/** The right hand state (State::ket vector). */
	State right;

};

/** Stream out first the left and then the right state.*/
std::ostream& operator<<(std::ostream& o, const StatePair& d);

#endif /* STATEPAIR_H_ */
