//============================================================================
// Name        : Solver
// Author      : Arbeitsgruppe Schmidt - Lehrstuhl für theoretische Physik 1
//               Fakultät Physik - TU Dortmund
// Version     : 0.4
// Copyright   : --
// Description : Solver for the Schrödingergleichung
//============================================================================


#include <Framework/Solver.h>

/** The global instance of the Solver class*/
Solver solver;

/** The main function executes the run function of the global Solver object.*/
int main(void) {

	// Execute the run function of the solver.
	int exitValue = solver.run();

	// Calculate the processing time of the solver.
	time_t processingTime = time(NULL) - solver.startingTime;

	time_t hours = processingTime / 3600;
	time_t minutes = processingTime / 60 - 60 * hours;
	time_t seconds = processingTime - hours * 3600 - minutes * 60;

	if (solver.globalConfiguration.verbosityLevel > 0)
		std::cerr << "Processing Time: " << hours << " hours, " << minutes
				<< " minutes and " << seconds << " seconds.\n";

	return exitValue;

}
