/*
 * DataProcessor.h
 *
 *  Created on: 17.11.2010
 *      Author: klagges
 *
 */

#ifndef DATAPROCESSOR_H_
#define DATAPROCESSOR_H_

/** A DataProcessor should read the Solver::inputSates and calculate the according
 Solver::outputState or Solver::outputAmplitude members. It can use the methods
 of the ModelProvider (i.e. solver.modules.pointerToProblemProvider->applyV(),... )
 and read the solver::modelProperties, solver::latticeProperties, solver::globalProperties
 and solver::globalConfiguration structures.

 You find an instruction how to create a new DataProcessor in
 Modules/DataProcessor/TemplateDataProcessor/TemplateDataProcessor.h.*/
class DataProcessor {

public:

	/** The method that is called by the solver class.
	 It must be overloaded by the implementation.*/
	virtual void execute() = 0;

};

#endif /* DATAPROCESSOR_H_ */
