/*
 * Configuration.h
 *
 *  Created on: 30.11.2011
 *      Author: klagges
 */

#ifndef LOEWDINCONFIGURATION_H_
#define LOEWDINCONFIGURATION_H_

#include <Utilities/ParameterSet.h>

namespace Loewdin {

/** Class to represent the the Loewdin configurations: coefficients-file, extra output. */
class Configuration: public Utilities::ParameterSet {

public:

	void streamOutExample(std::ostream& stream);

	void streamIn(std::istream& stream);

	/** The coefficients file to use. */
	std::string nameOfCoefficientsFile;

	/** If '1', the internally calculated energy values should be given out through the std::cout pipe.
	 * The format is E[0]*h^1+E[1]*h^2+E[2]*h^3 usw. */
	bool extraOutput;

};

} /* namespace Loewdin */
#endif /* LOEWDINCONFIGURATION_H_ */
