/*
 * Term.cpp
 *
 *  Created on: 22.11.2010
 *      Author: klagges
 */

#include <Modules/DataProcessor/Loewdin/Common/Term.h>
#include <Utilities/TypeCast.h>

Loewdin::Term::Term() {

	factor = 1;

}

std::ostream& Loewdin::operator<<(std::ostream& o, const Term& d) {

	o << d.order << " ";

	o << d.factor << " ";

	for (unsigned int i = 0; i < d.E.size(); i++) {
		o << d.E[i] << " ";
	}

	o << d.operators;

	return o;

}

std::istream& Loewdin::operator>>(std::istream& i, Term& d) {

	i >> d.order;

	d.E.resize(std::max(0, (int) d.order - 2));

	int temp;
	i >> temp;
	Utilities::typeCast(temp, d.factor);

	int eOrder = 0;

	for (unsigned int j = 0; j < d.E.size(); j++) {

		i >> d.E[j];

		eOrder += (j + 1) * d.E[j];

	}

	d.operatorOrder = d.order - eOrder;

	i >> d.operators;

	return i;

}
