/*
 * Configuration.h
 *
 *  Created on: 26.04.2011
 *      Author: kamfor
 */

#ifndef PCUTCONFIGURATION_H_
#define PCUTCONFIGURATION_H_

#include <Utilities/ParameterSet.h>
#include <string>

/** Class to represent the the PCUT configurations: coefficients-file, qp-number. */

namespace PCUT {

class Configuration: public Utilities::ParameterSet {

public:

	void streamOutExample(std::ostream& stream);

	void streamIn(std::istream& stream);

	/** The coefficients file to use. */
	std::string nameOfCoefficientsFile;

	/** Number of quasi-particles in the current qp-sector. The default value is -1, meaning the qp-sector is not specified. */
	short numberOfQuasiParticles;

};

}

#endif /* PCUTCONFIGURATION_H_ */
