/*
 * Coefficients.cpp
 *
 *  Created on: 15.04.2010
 *      Author: kamfor, klagges
 */

#include <Modules/DataProcessor/PCUT/TreeSolver/TreeSolver.h>
#include <Framework/Solver.h>

void PCUT::TreeSolver::Coefficients::streamOutExample(std::ostream& stream) {

	stream << "# Here should be a coefficients file\n\n"
			<< "# No order present\n0";

}

void PCUT::TreeSolver::Coefficients::streamIn(std::istream& stream) {

	// Stream in the coefficients.
	Term t;

	stream >> t;

	while (stream.good()) {

		// We only read in the coefficients up to the desired order.
		if (t.operators.size() > solver.globalConfiguration.order)
			break;

		// And skip the coefficients with too low order.
		if (t.operators.size() >= solver.globalConfiguration.minOrder)
			root.insertTerm(t);

		stream >> t;

	}

	root.sortRecursively();

	//	if (c.begin()->operators.size() < solver.globalConfiguration.order) {
	//		if (solver.globalConfiguration.verbosityLevel > 0)
	//			std::cerr << "Warning! Calculation up to order "
	//					<< solver.globalConfiguration.order
	//					<< " is requested, but only coefficients up to order "
	//					<< c.begin()->operators.size() << " are present!\n";
	//	}
}

std::ostream& PCUT::operator<<(std::ostream& o,
		PCUT::TreeSolver::Coefficients& c) {

	c.root.streamOutRecursively(Term(), o);
	o << "\n";
	c.root.streamOutRecursivelyAsTree(std::list<char>(), o);

	return o;
}

