/*
 * TakahashiDrectSolver.cpp
 *
 *  Created on: 17.11.2010
 *      Author: klagges
 *
 */

#include <Modules/DataProcessor/Takahashi/TreeSolver/TreeSolver.h>
#include <Framework/Solver.h>

Takahashi::TreeSolver::TreeSolver() {

	nameOfCoefficientsFile.readFromConfigFile("TakahashiConfiguration.cfg");

	coefficients.readFromCoefficientsFile(nameOfCoefficientsFile.value);

	coefficients.root.calculateRemainingVRecursively();
	coefficients.root.shrinkNodes();
	coefficients.root.sortRecursively();

	//std::cout << coefficients.root;

}

void Takahashi::TreeSolver::execute() {

	solver.globalConfiguration.currentOrder = 0;

	// Calculate the output states by the DFS through the tree.
	coefficients.root.calculateOutputStateRecursively(solver.inputStates.right,
			solver.outputState, std::string());

	if (solver.globalConfiguration.verbosityLevel > 1)
		std::cerr << "\n";

}

