/*
 * ListedTerm.cpp
 *
 *  Created on: 22.02.2011
 *      Author: klagges
 */

#include <Modules/DataProcessor/Takahashi/TwoSideSolver/TwoSideSolver.h>

std::ostream& Takahashi::operator<<(std::ostream& o,
		TwoSideSolver::ListedTerm& tsor) {


	o << "Left side : ";

	for (std::list<Utilities::OperatorDescription>::iterator
			it = tsor.leftSideOperators.begin(); it
			!= tsor.leftSideOperators.end(); it++) {

		o << *it;

	}
	o << "\nRight side: ";
	for (std::list<Utilities::OperatorDescription>::iterator
			it = tsor.rightSideOperators.begin(); it
			!= tsor.rightSideOperators.end(); it++) {

		o << *it;

	}

	o << "\n\n";



	return o;

}

bool Takahashi::operator<(const TwoSideSolver::ListedTerm& l,
		const TwoSideSolver::ListedTerm& r) {

	if (l.term.order < r.term.order)
		return true;
	if (l.term.order == r.term.order)
		if (l.term.operators < r.term.operators)
			return true;

	return false;

}
