/*
 * TemplateDataProcessor.cpp
 *
 *  Created on: 17.11.2010
 *      Author: klagges
 *
 */

#include <Modules/DataProcessor/TemplateDataProcessor/TemplateDataProcessor.h>
#include <Interface/StateIO.h>

// The constructor should initialize all data needed for the implementation.
// (i.e. the coefficients file)
TemplateDataProcessor::TemplateDataProcessor() {

	//templateParameterSet.readFromFile("TemplateParameterSet.cfg");

}

// The method that is called by the solver class.
// In the module implementation this method is no longer virtual.
void TemplateDataProcessor::execute() {

	std::cout << "I should reed the inputStates here, i.e. the right one:\n"
			<< solver.inputStates.right << "\n";

	std::cout << "and maybe the left as well :\n"
			<< solver.inputStates.left << "\n";

	std::cout
			<< "and calculate the according output states or output coefficients.\n\n";

	std::cout
			<< "I can do this by applying i.e. the problem specific V operator to this input state:\n";

	State result;
	solver.modules.pointerToModelProvider->applyV(solver.inputStates.right,
			result, 100);

	std::cout << result << "\n\n";

	std::cout
			<< "I can use the global configuration like the order to which i should calculate: "
			<< solver.globalConfiguration.order << "\n";

	std::cout
			<< "and the problem specific properties, like the maximal number N so that V = T_0 + T_1 + T_-1 + ... + T_N + T_-N : "
			<< solver.modelProperties.Nmax << "\n\n";

	solver.outputState = result;

	std::cout
			<< "Just set the output State to the calculated state:\n"
			<< solver.outputState << "\n\n";

	solver.outputAmplitude = solver.inputStates.right.begin()->second;

	std::cout
			<< "Just set the first output Coefficient to the first base state coefficient of the input state:\n"
			<< solver.outputAmplitude << "\n\n\n";

}
