/*
 * ClusterFidelity.cpp
 *
 *  Created on: 17.11.2010
 *      Author: klagges
 *
 * A template for implementation of modules.
 *
 */

#include <Modules/DataWriter/ClusterFidelity/ClusterFidelity.h>
#include <Interface/StateIO.h>

ClusterFidelity::ClusterFidelity() {

	//templateParameterSet.readFromFile("TemplateParameterSet.cfg");
	clusterState.readFromConfigFile(
			"LatticeModels/RotatedTwoSpinClusterWithZZ/lambda=0.5/cs.op");

}

// Only a simple output.
void ClusterFidelity::execute() {

	stateAmplitude fidelity(amplitude(0));

	unsigned int numberOfSites = solver.latticeProperties.numberOfLatticeSites;

	for (State::const_iterator it = solver.outputState.begin(); it
			!= solver.outputState.end(); it++) {

		double factor = 1;

		for (unsigned int latticeSiteCounter = 0; latticeSiteCounter
				< numberOfSites; latticeSiteCounter++) {

			unsigned int localBaseState = it->first.toInteger(
					latticeSiteCounter * 4, (latticeSiteCounter + 1) * 4);

			factor *= clusterState[localBaseState];

		}

		amplitude convertedFactor;
		Utilities::typeCast(factor, convertedFactor);
		fidelity += it->second * convertedFactor;

	}

	std::cout << fidelity << "\n";

}
