/*
 * ClusterFidelity.h
 *
 *  Created on: 17.11.2010
 *      Author: klagges
 *
 * A template for implementation of a DataWriter. To create your own DataWriter:
 *
 * - Create a folder for your module. Copy and rename ClusterFidelity.h
 *   and ClusterFidelity.cpp to it. Adapt the class name.
 *
 * - Add your .cpp file to the Makefile to make sure it will be compiled.
 *
 * - Register the new module in the Framework/Module.cpp file, by including the
 *   new header file and adding a new MODULE(...) line.
 *
 * - Be aware, that module implementations are only instantiated and called, if
 *   they are entered in the Config/Modules.cfg file.
 *
 */

#ifndef CLUSTERFIDELITY_H_
#define CLUSTERFIDELITY_H_

#include <Modules/DataWriter/DataWriter.h>
#include <iostream>
#include <Utilities/DiagonalOperator.h>
//#include <Framework/TemplateParameterSet.h>

/** A data writer intended to be used with the RotatedTwoSpinClusterWithZZ model provider.
 * It calculates the fidelity of the outputState with the logical cluster state and prints it to std::cout.*/
class ClusterFidelity: public DataWriter {

public:

	/** Default constructor.*/
	ClusterFidelity();

	/** The virtual method that is called by the solver class.
	 In the module implementation this method is overloaded.*/
	void execute();

private:

	// Add members and methods you need for the calculations of your module here.

	//TemplateParameterSet templateParameterSet;

	Utilities::DiagonalOperator clusterState;

};

#endif /* CLUSTERFIDELITY_H_ */
