/*
 * DataWriter.h
 *
 *  Created on: 17.11.2010
 *      Author: klagges
 *
 */

#ifndef DATAWRITER_H_
#define DATAWRITER_H_

/** A DataWriter should read the members of the Solver object and give them
 out in some meaning full way.

 All post processing of the result should be done here as well.

 You find an instruction how to create new a new DataWriter in
 Modules/DataWriter/TemplateDataWriter/TemplateDataWriter.h.*/
class DataWriter {

public:

	/** The virtual function that need to be overloaded by the module implementations.
	 It will be called by the run function of the Solver class.*/
	virtual void execute() = 0;

};

#endif /* DATAWRITER_H_ */
