/*
 * TCLFWriter.cpp
 *
 *  Created on: 17.11.2011
 *      Author: kamfor
 */

#include <Modules/DataWriter/TCLFWriter/TCLFWriter.h>
#include <Modules/ModelProvider/GeneralLatticeModel/GeneralLatticeModel.h>
#include <Interface/BaseState.h>
#include <Interface/BaseStateIO.h>
#include <Interface/StateIO.h>
#include <Interface/ExpandedAmplitudeIO.h>
#include <Utilities/Utilities.h>
#include <string>

TCLFWriter::TCLFWriter() {

}

void TCLFWriter::execute() {

	//    unsigned int PosIn  = (solver.inputStates.left.begin()->first).find1();
	//	unsigned int PosOut = (solver.inputStates.right.begin()->first).find1();
	//
	//    std::cout <<"{"<<solver.configurationDirectory<<", "<< PosIn <<", "<< PosOut <<", "<< solver.outputAmplitude <<"}"<< std::endl;


	//    std::cout <<"{"<<solver.configurationDirectory<<", "<< solver.outputAmplitude <<"}"<< std::endl;


	//		for (State::const_iterator it = solver.outputState.begin(); it
	//				!= solver.outputState.end(); it++)
	//		 std::cout <<"hi: " <<it->second<<" x "<< it->first << std::endl;


	/** List all flipped Z2-degrees of freedom in the input state */

	// List of "sites -> cluster parameters" for clusters up to order 8 (not-rotated clusters!).
	// Starting from order 9 the list is not anymore bijective (cluster 4x2 and 7x1 have both 23 sites)

	std::string Clusterlist[150];
	Clusterlist[5] = "{1,1}";
	Clusterlist[8] = "{2,1}";
	Clusterlist[13] = "{2,2}";
	Clusterlist[11] = "{3,1}";
	Clusterlist[18] = "{3,2}";
	Clusterlist[25] = "{3,3}";
	Clusterlist[14] = "{4,1}";
	Clusterlist[23] = "{4,2}";
	Clusterlist[32] = "{4,3}";
	Clusterlist[41] = "{4,4}";
	Clusterlist[17] = "{5,1}";
	Clusterlist[28] = "{5,2}";
	Clusterlist[39] = "{5,3}";
	Clusterlist[50] = "{5,4}";
	Clusterlist[61] = "{5,5}";
	Clusterlist[20] = "{6,1}";
	Clusterlist[33] = "{6,2}";
	Clusterlist[46] = "{6,3}";
	Clusterlist[59] = "{6,4}";
	Clusterlist[72] = "{6,5}";
	Clusterlist[85] = "{6,6}";
	Clusterlist[23] = "{7,1}";
	Clusterlist[38] = "{7,2}";
	Clusterlist[53] = "{7,3}";
	Clusterlist[68] = "{7,4}";
	Clusterlist[83] = "{7,5}";
	Clusterlist[98] = "{7,6}";
	Clusterlist[113] = "{7,7}";
	Clusterlist[26] = "{8,1}";
	Clusterlist[43] = "{8,2}";
	Clusterlist[60] = "{8,3}";
	Clusterlist[77] = "{8,4}";
	Clusterlist[94] = "{8,5}";
	Clusterlist[111] = "{8,6}";
	Clusterlist[128] = "{8,7}";
	Clusterlist[145] = "{8,8}";

	std::string stringOfBits;
	std::stringstream tmpStream;

	tmpStream << (solver.inputStates.right);
	stringOfBits = tmpStream.str();

	stringOfBits.erase(0, stringOfBits.find_first_of("|") + 1);
	stringOfBits.erase(stringOfBits.find_first_of(">"), stringOfBits.size()
			- stringOfBits.find_first_of(">"));

	unsigned int counter = 0;
	unsigned int gate = 0;
	std::cout << "{";
	std::cout << Clusterlist[solver.latticeProperties.numberOfLatticeSites]
			<< ",";
	std::cout << "{";
	for (std::string::const_iterator str_it = stringOfBits.begin(); str_it
			< stringOfBits.end(); str_it++) {

		if ((*str_it) == '1') {
			if (gate != 0)
				std::cout << ",";
			std::cout << counter;
			gate = 1;
		}

		counter += 1;
	}
	std::cout << "},";

	/** List all flipped Z2-degrees of freedom in the output states */

	if (solver.outputState.size() != 0) {
		std::cout << "{";
		gate = 0;
		for (State::const_iterator it = solver.outputState.begin(); it
				!= solver.outputState.end(); it++) {

			stringOfBits.clear();
			tmpStream.str(std::string());

			tmpStream << (it->first);
			stringOfBits = tmpStream.str();

			stringOfBits.erase(0, stringOfBits.find_first_of("|") + 1);
			stringOfBits.erase(stringOfBits.find_first_of(">"),
					stringOfBits.size() - stringOfBits.find_first_of(">"));

			counter = 0;
			if (gate == 1)
				std::cout << ",";
			std::cout << "{";
			std::cout << "{";
			gate = 0;

			for (std::string::const_iterator str_it = stringOfBits.begin(); str_it
					< stringOfBits.end(); str_it++) {

				if ((*str_it) == '1') {
					if (gate != 0)
						std::cout << ",";
					std::cout << counter;
					gate = 1;
				}

				counter += 1;
			}
			std::cout << "}," << it->second << "}";
		}
		std::cout << "}}\n";
	} else
		std::cout << "{}}\n";
}

