/*
 * TemplateDataWriter.h
 *
 *  Created on: 17.11.2010
 *      Author: klagges
 *
 * A template for implementation of a DataWriter. To create your own DataWriter:
 *
 * - Create a folder for your module. Copy and rename TemplateDataWriter.h
 *   and TemplateDataWriter.cpp to it. Adapt the class name.
 *
 * - Add your .cpp file to the Makefile to make sure it will be compiled.
 *
 * - Register the new module in the Framework/Module.cpp file, by including the
 *   new header file and adding a new MODULE(...) line.
 *
 * - Be aware, that module implementations are only instantiated and called, if
 *   they are entered in the Config/Modules.cfg file.
 *
 */

#ifndef TEMPLATEDATAWRITER_H_
#define TEMPLATEDATAWRITER_H_

#include <Modules/DataWriter/DataWriter.h>
#include <iostream>
//#include <Framework/TemplateParameterSet.h>

/** A template for a DataWriter.
 * You find an instruction how to create new a new DataWriter in
 * Modules/DataWriter/TemplateDataWriter/TemplateDataWriter.h.*/
class TemplateDataWriter: public DataWriter {

public:

	/** Default constructor.*/
	TemplateDataWriter();

	/** The virtual method that is called by the solver class.
	 In the module implementation this method is overloaded.*/
	void execute();

private:

	// Add members and methods you need for the calculations of your module here.

	//TemplateParameterSet templateParameterSet;


};

#endif /* TEMPLATEDATAWRITER_H_ */
