/*
 * RotatedClusterGapAndGroundState.h
 *
 *  Created on: 21.09.2011
 *      Author: klagges
 */

#ifndef CLUSTERINFIELDGAPANDGROUNDSTATE_H_
#define CLUSTERINFIELDGAPANDGROUNDSTATE_H_

#include <Modules/LatticeProvider/LatticeProvider.h>
#include <Utilities/ParameterSet.h>
#include <Interface/Interface.h>
#include <Interface/Bond.h>

/** A LatticeProvider that loads the latticeProperties and the inputStates from files.
 * The DataProcessor is executed once.*/
class ClusterInFieldGapAndGroundState: public LatticeProvider {
public:

	ClusterInFieldGapAndGroundState();

	bool execute();

private:

	/** To keep track of the phase of the calculation. */
	enum Progress {

		initial, calculateExitedEnergy, calculateGroundEnergy

	};

	/** To keep track of the phase of the calculation. */
	Progress progress;

	Bond newhzBond;
	Bond newBond;

};

#endif /* CLUSTERINFIELDGAPANDGROUNDSTATE_H */
