/*
 * LatticeFileLoader.cpp
 *
 *  Created on: 21.09.2011
 *      Author: klagges
 */

#include <Modules/LatticeProvider/LatticeFileLoader/LatticeFileLoader.h>
#include <Framework/Solver.h>

LatticeFileLoader::LatticeFileLoader() {

	// LatticeFileLoader not yet executed.
	executed = false;

	configuration.readFromConfigFile("LatticeFileLoader.cfg");

}

bool LatticeFileLoader::execute() {

	if (executed)
		return false; // Data processor was executed and we are done.

	// Load the bond file and the input states.
	solver.latticeProperties.readFromConfigFile(
			"BondFiles/" + configuration.bondFileName);
	solver.inputStates.readFromConfigFile(
			"BondFiles/" + configuration.inputStatesName);

	executed = true;
	return true;

}
