/*
 * LatticeFileLoader.h
 *
 *  Created on: 21.09.2011
 *      Author: klagges
 */

#ifndef LATTICEFILELOADER_H_
#define LATTICEFILELOADER_H_

#include <Modules/LatticeProvider/LatticeProvider.h>
#include <Utilities/ParameterSet.h>

/** A LatticeProvider that loads the latticeProperties and the inputStates from files.
 * The DataProcessor is executed once.*/
class LatticeFileLoader: public LatticeProvider {
public:

	LatticeFileLoader();

	bool execute();

private:

	/** Class to hold the configuration of the LatticeFileLoader. */
	class Configuration: public Utilities::ParameterSet {

	public:

		void streamOutExample(std::ostream& stream);

		void streamIn(std::istream& stream);

		/** The name of the bond file to use. */
		std::string bondFileName;

		/** The name of the file to load the input states from.*/
		std::string inputStatesName;

	};

	/** The configuration.*/
	Configuration configuration;

	/** Boolean variable to store if the LatticeFileLoader was executed before.
	 * Used to make sure, that the DataProcessor is only executed once..*/
	bool executed;

};

#endif /* LATTICEFILELOADER_H_ */
