/*
 * LatticeProvider.h
 *
 *  Created on: 26.10.2010
 *      Author: klagges
 *
 */

#ifndef LATTICEPROVIDER_H_
#define LATTICEPROVIDER_H_

/** A LatticeProvider should fill the solver::latticeProperties and the solver::inputStates fields of the ::solver object
 * and interpret the results of the DataProcessor.
 *
 * When the LatticeProvider is called first, it should fill the solver::latticeProperties and the solver::inputStates.
 * As long it returns true, the DataProcessor is called and the LatticeProvider is called again to set up the
 * solver::latticeProperties and the solver::inputStates for the next calculation.
 * If no more calculations are necessary it should return false and the DataWriter is called.
 *
 * */
class LatticeProvider {

public:

	/** The virtual function that need to be overloaded by the module implementations.
	 It will be called by the run function of the Solver class.*/
	virtual bool execute() = 0;

};

#endif /* LATTICEPROVIDER_H_ */
