/*
 * RotatedClusterGapAndGroundState.h
 *
 *  Created on: 21.09.2011
 *      Author: klagges
 */

#ifndef ROTATEDCLUSTERGAPANDGROUNDSTATE_H_
#define ROTATEDCLUSTERGAPANDGROUNDSTATE_H_

#include <Modules/LatticeProvider/LatticeProvider.h>
#include <Utilities/ParameterSet.h>

/** A LatticeProvider that loads the latticeProperties and the inputStates from files.
 * The DataProcessor is executed once.*/
class RotatedClusterGapAndGroundState: public LatticeProvider {
public:

	RotatedClusterGapAndGroundState();

	bool execute();

private:

	/** To keep track of the phase of the calculation. */
	enum Progress {

		initial, calculateExitedEnergy, calculateGroundEnergy

	};

	/** To keep track of the phase of the calculation. */
	Progress progress;

};

#endif /* ROTATEDCLUSTERGAPANDGROUNDSTATE_H_ */
