/*
 * TemplateLatticeProvider.h
 *
 *  Created on: 26.10.2010
 *      Author: klagges
 *
 * A template for implementation of modules. To create your own implementations:
 *
 * - Create a folder for your module. Copy and rename TemplateLatticeProvider.h
 *   and TemplateLatticeProvider.cpp to it. Adapt the class name.
 *
 * - Add your .cpp file to the Makefile to make sure it will be compiled.
 *
 * - Register the new module in the Framework/Module.cpp file, by including the
 *   new header file and adding a new MODULE(...) line.
 *
 * - Be aware, that module implementations are only instantiated and called, if
 *   they are entered in the Config/Modules.cfg file.
 *
 */

#ifndef TEMPLATELATTICEPROVIDER_H_
#define TEMPLATELATTICEPROVIDER_H_

#include <Modules/LatticeProvider/LatticeProvider.h>

/** A template for a LatticeProvider.
 * You find an instruction how to create new module implementations in
 * Modules/LatticeProvider/TemplateLatticeProvider/TemplateLatticeProvider.h. */
class TemplateLatticeProvider: public LatticeProvider {

public:

	/** The constructor should initialize all data needed for the implementation.*/
	TemplateLatticeProvider();

	bool execute();

private:

	// Add all data and methods needed by your implementation here.

	/** Boolean variable to store if the LatticeProvider was executed before.
	 * Used to make sure, that the DataProcessor is only executed once..*/
	bool executed;

};

#endif /* TEMPLATELATTICEPROVIDER_H_ */
