/*
 * FermionicHubbard.cpp
 *
 *  Created on: 27.10.2011
 *      Author: ixert
 */

#include <Modules/ModelProvider/FermionicHubbard/FermionicHubbard.h>
#include <Interface/BaseStateIO.h>
#include <Interface/ExpandedAmplitudeIO.h>
#include <Framework/Solver.h>

void FermionicHubbard::updateOutputAmplitude(const BaseState & outputState,
		const BaseState & inputState, stateAmplitude & outputAmplitude,
		const stateAmplitude & inputAmplitude, const Bond & bond) {

	//std::cout << "\n\nOutputState: " << outputState << "\n";
	//std::cout << "OutputAmplitude: " << outputAmplitude << "\n";
	//std::cout << "InputState: " << inputState << "\n";
	//std::cout << "InputAmplitude: " << inputAmplitude << "\n";

	unsigned int destroyedBit=0;
	unsigned int createdBit=0;
	amplitude vz(1);

	for(unsigned int i=0;i<solver.modelProperties.bitsPerLatticeSite*solver.latticeProperties.numberOfLatticeSites;i++){
		if(!outputState.get(i) && inputState.get(i)){
			destroyedBit=i;
		}
		else{
			if(outputState.get(i) && !inputState.get(i)){
				createdBit=i;
			}
		}
	}
	//std::cout << "destroyedBit=" << destroyedBit << " createdBit=" << createdBit << "\n";
	for(unsigned int i=0;i<destroyedBit;i++){
		if(inputState.get(i)){
			vz*=-1;
		}
	}
	for(unsigned int i=0;i<createdBit;i++){
		if(outputState.get(i)){
			vz*=-1;
		}
	}
	//std::cout << "vz=" << vz << "\n\n";
	outputAmplitude *= vz;

}

