/*
 * Configuration.cpp
 *
 *  Created on: 01.02.2011
 *      Author: klagges
 */

#include <Modules/ModelProvider/String_Net_Models/String_Net_Models.h>

void String_Net_Models::Configuration::streamOutExample(std::ostream& stream) {

	stream << "# This is a configuration file for a lattice model.\n\n"
			<< "# The number of bits used to represent the Hilbert space of a single lattice site.\n"
			<< "2\n\n" << "# The number of expansion parameters\n" << "1\n\n"
			<< "# The number of perturbation operators.\n"
			<< "# Can be bigger then the number of expansion parameters if multiple operators are\n"
			<< "# associated with the same expansion parameter.\n" << "1\n\n"
			<< "# This the minimal numbers N so that all perturbation operators\n"
			<< "# can be written in the form V = T_0 + T_1 + T_{-1} + ... + T_N + T_{-N}.\n"
			<< "2\n\n"
			<< "# The sub folder where to find the definitions of the local H and T_i operators\n"
			<< "./\n";

}

void String_Net_Models::Configuration::streamIn(std::istream& stream) {

	stream >> bitsPerLatticeSite >> numberOfExpansionParameters
			>> numberOfPerturbationOperators >> Nmax >> operatorsSubFolderName;

}
