/*
 * TemplateModelProvider.h
 *
 *  Created on: 17.11.2010
 *      Author: klagges
 *
 * A template for implementation of a ModelProvider. To create your own ModelProvider:
 *
 * - Create a folder for your module. Copy and rename TemplateModelProvider.h
 *   and TemplateModelProvider.cpp to it. Adapt the class name.
 *
 * - Add your .cpp file to the Makefile to make sure it will be compiled.
 *
 * - Register the new module in the Framework/Module.cpp file, by including the
 *   new header file and adding a new MODULE(...) line.
 *
 * - Be aware, that module implementations are only instantiated and called, if
 *   they are entered in the Config/Modules.cfg file.
 *
 */

#ifndef TEMPLATEMODELPROVIDER_H_
#define TEMPLATEMODELPROVIDER_H_

#include <Modules/ModelProvider/ModelProvider.h>
//#include <Framework/TemplateParameterSet.h>

/** A template for a ModelProvider.
 * You find an instruction how to create new a new ModelProvider in
 * Modules/ModelProvider/TemplateModelProvider/TemplateModelProvider.h.*/
class TemplateModelProvider: public ModelProvider {

public:

	/** Should at fill the Solver::modelProperties.*/
	TemplateModelProvider();

	void applyT(const State& source, State& result, int c);

	double getH_0Eigenvalue(const BaseState& bs);

private:

	// Add members and methods you need for the calculations of your module here.

	//TemplateParameterSet templateParameterSet;


};

#endif /* TEMPLATEMODELPROVIDER_H_ */
