/*
 * Conjugate.h
 *
 *  Created on: 17 oct. 2011
 *      Author: kamfor
 */

#ifndef CONJUGATE_H_
#define CONJUGATE_H_

#include <complex.h>
#include <Interface/State.h>
#include <sstream>

namespace Utilities {

/** Non complex data types do not conjugate.*/
template<typename T>
inline void ComplexConjugate(T & value) {

}

/** Complex conjugate of a complex number*/
template<typename T>
inline void ComplexConjugate(std::complex<T> & value) {

	value=std::conj(value);

}

/** Complex conjugate of a complex ExpandedAmplitude*/
template<typename cont, typename exp, typename T>
inline void ComplexConjugate(
		ExpandedAmplitudeTemplate<cont, exp, std::complex<T> > & value) {

	for (typename cont::iterator it = value.begin(); it != value.end(); it++) {

		ComplexConjugate(it->second);

	}

}

/** Complex conjugate of complex State. */
template<typename cont, typename base, typename T>
inline void ComplexConjugate(StateTemplate<cont, base, std::complex<T> > & value) {

	for (typename cont::iterator it = value.begin(); it != value.end(); it++) {

		ComplexConjugate(it->second);

	}

}

/** Complex conjugate of complex ExpandedAmplitude State. */
template<typename cont, typename base, typename cont2, typename exp, typename T>
inline void ComplexConjugate(StateTemplate<cont, base, ExpandedAmplitudeTemplate<cont2, exp, std::complex<T> > > & value) {

	for (typename cont::iterator it = value.begin(); it != value.end(); it++) {

		ComplexConjugate(it->second);

	}

}

}

#endif /* CONJUGATE_H_ */
