/*
 * IsPositive.h
 *
 *  Created on: 04.10.2011
 *      Author: klagges
 */

#ifndef ISPOSITIVE_H_
#define ISPOSITIVE_H_

#include <complex.h>
#include <Interface/ExpandedAmplitude.h>

namespace Utilities {

/** Test if value is positive*/
template<typename T>
inline bool isPositive(const T & value) {
	return value >= 0;
}

template<typename T>
inline bool isPositive(const std::complex<T> & value) {
	// Complex numbers cannot really be positive, but we say true,
	// to make sure a '+' is correctly given out by various stream methods.
	return true;
}

template<typename cont, typename exp, typename amp>
inline bool isPositive(const ExpandedAmplitudeTemplate<cont, exp, amp> & value) {
	// We give out false to make sure no '+' is given out.
	return false;
}

}

#endif /* ISPOSITIVE_H_ */
