/*
 * StreamableAmplitude.h
 *
 *  Created on: 20.09.2011
 *      Author: klagges
 */

#ifndef STREAMABLEAMPLITUDE_H_
#define STREAMABLEAMPLITUDE_H_

#include <Interface/Interface.h>
#include <Utilities/TypeCast.h>

namespace Utilities {

/** Stores a single value of type amplitude.
 * the value can be streamed in from a configuration file. It is assumed
 * that the value in the configuration file is of type T. */
template<typename T>
class StreamableAmplitude: public Utilities::ParameterSet {
public:

	void streamOutExample(std::ostream& stream) {
		stream
				<< "# This is an example for configuration file containing a single value of a given type.\n"
				<< "# It is stored as a value of type 'amplitude'.\n"
				<< "# You should add a description what it is used for.\n"
				<< "0\n";
	}

	void streamIn(std::istream& stream) {

		T temp;

		stream >> temp;

		Utilities::typeCast(temp, value);

	}

	/** The amplitude value that can be streamed.*/
	amplitude value;

};

}

#endif /* STREAMABLEAMPLITUDE_H_ */
