/*
 * StreamableBaseType.h
 *
 *  Created on: 20.09.2011
 *      Author: klagges
 */

#ifndef STREAMABLEBASETYPE_H_
#define STREAMABLEBASETYPE_H_

#include <Utilities/ParameterSet.h>

namespace Utilities {

/** Stores a single value of base type T.
 * It can be streamed in from a configuration file.*/
template<typename T>
class StreamableBaseType: public Utilities::ParameterSet {
public:

	void streamOutExample(std::ostream& stream) {
		stream
				<< "# This is an example for configuration file containing a single base type value.\n\n"
				<< "# You should add a description what it is used for.\n"
				<< "0\n";
	}

	void streamIn(std::istream& stream) {

		stream >> value;

	}

	/** The base type value that can be streamed.*/
	T value;

};

}

#endif /* STREAMABLEBASETYPE_H_ */
