/*
 * TemplateParameterSet.h
 *
 *  Created on: 26.10.2010
 *      Author: klagges
 *
 * TemplateParameterSet is an example for a parameter set.
 *
 * To create your own parameter set follow the following steps.
 *
 * - Copy TemplateParameterSet.h and TemplateParameterSet.cpp to the name
 *   and place of your parameter set. Adapt the class name.
 *
 * - Add your .cpp file to the Makefile to make sure it is compiled.
 *
 * - Add your parameters.
 *
 * - Overload the streamOutExample and streamIn functions accordingly.
 *
 */

#ifndef TEMPLATEPARAMETERSET_H_
#define TEMPLATEPARAMETERSET_H_

#include <Utilities/ParameterSet.h>

namespace Utilities {

/** A template for a ParameterSet.*/
class TemplateParameterSet : public Utilities::ParameterSet {

public:

	// this are the virtual functions that need to be overloaded.

	void streamOutExample(std::ostream& stream);

	void streamIn(std::istream& stream);

	/** Add your parameters here*/
	int exampleParameter;

};

}
#endif /* TEMPLATEPARAMETERSET_H_ */
