/*
 * Utilities.cpp
 *
 *  Created on: 24.11.2010
 *      Author: klagges
 */

#include <Utilities/Utilities.h>

std::string Utilities::intToBinary(unsigned int i, unsigned int bits) {

	std::string output(bits, '0');

	unsigned int mask = 1;
	unsigned int position = bits;

	while (position > 0) {

		position--;
		if (i & mask)
			output[position] = '1';
		mask = mask << 1;

	}

	return output;

}

std::string Utilities::intToBinaryReverted(unsigned int i, unsigned int bits) {

	std::string output(bits, '0');

	unsigned int mask = 1;
	unsigned int position = 0;

	while (position < bits) {

		if (i & mask)
			output[position] = '1';
		mask = mask << 1;
		position++;

	}

	return output;

}

unsigned int Utilities::binaryToInt(std::string s) {

	std::string::iterator it = s.end();

	unsigned int mask = 1;
	unsigned int output = 0;

	while (it != s.begin()) {
		it--;
		if (*it == '1')
			output += mask;
		mask = mask << 1;

	}

	return output;

}

