/*
 * Utilities.h
 *
 *  Created on: 24.11.2010
 *      Author: klagges
 */

#ifndef UTILITIES_H_
#define UTILITIES_H_

#include <Interface/ExpandedAmplitude.h>
#include <gmpxx.h>
#include <string>

/** Feel free to add utility methods here.*/
namespace Utilities {

/** Converts an unsigned integer to a string of bits zeros and ones like 0100.*/
std::string intToBinary(unsigned int i, unsigned int bits);

/** Converts an unsigned integer to a string of bits zeros and ones like 0010,
 * but with reverted order (least significant bit to the left).*/
std::string intToBinaryReverted(unsigned int i, unsigned int bits);

/** Converts a string of zeros and ones like 0100 into an unsigned integer.*/
unsigned int binaryToInt(std::string s);

/** Algorithm for fast exponentiation.*/
template<typename T>
T pow(T base, unsigned int exponent) {

	T result(1);
	while (exponent != 0) {
		if (exponent & 1)
			result *= base;

		base *= base;
		exponent >>= 1;

	}

	return result;
}

}

#endif /* UTILITIES_H_ */
