/*
 * SpinOperatorsOnSitesXYBasis.cpp
 *
 *  Created on: Sep 11, 2014
 *      Author: ixert
 */

#include "SpinOperatorsOnSitesXYBasis.h"
#include "SpinOperatorsOnSitesPMBasis.h"

SpinOperatorsOnSitesXYBasis::SpinOperatorsOnSitesXYBasis(){
}

list<pair<SpinOperatorsOnSitesPMBasis,int> > SpinOperatorsOnSitesXYBasis::convertToPMBasis(){
	list<pair<SpinOperatorsOnSitesPMBasis,int> > retList;
	retList.push_back(pair<SpinOperatorsOnSitesPMBasis,int>(SpinOperatorsOnSitesPMBasis(),1));
	for(unsigned int i=0;i<operatorSequence.size();i++){
		list<pair<SpinOperatorsOnSitesPMBasis,int> > tempList;
		list<pair<SpinOperatorsOnSitesPMBasis,int> > ::iterator itList;
		for(itList=retList.begin();itList!=retList.end();itList++){
			switch(operatorSequence[i].second){
				case 'x':{
					SpinOperatorsOnSitesPMBasis tempOp=itList->first;
					tempOp.insertNewOperator('p',operatorSequence[i].first);
					tempList.push_back(pair<SpinOperatorsOnSitesPMBasis,int>(tempOp,itList->second));
					tempOp=itList->first;
					tempOp.insertNewOperator('m',operatorSequence[i].first);
					tempList.push_back(pair<SpinOperatorsOnSitesPMBasis,int>(tempOp,itList->second));
					break;
				}
				case 'y':{
					SpinOperatorsOnSitesPMBasis tempOp=itList->first;
					tempOp.insertNewOperator('p',operatorSequence[i].first);
					tempList.push_back(pair<SpinOperatorsOnSitesPMBasis,int>(tempOp,itList->second));
					tempOp=itList->first;
					tempOp.insertNewOperator('m',operatorSequence[i].first);
					tempList.push_back(pair<SpinOperatorsOnSitesPMBasis,int>(tempOp,-itList->second));
					break;
				}
				case 'z':{
					SpinOperatorsOnSitesPMBasis tempOp=itList->first;
					tempOp.insertNewOperator('z',operatorSequence[i].first);
					tempList.push_back(pair<SpinOperatorsOnSitesPMBasis,int>(tempOp,itList->second));
					break;
				}
				case 'E':{
					SpinOperatorsOnSitesPMBasis tempOp=itList->first;
					tempOp.insertNewOperator('E',operatorSequence[i].first);
					tempList.push_back(pair<SpinOperatorsOnSitesPMBasis,int>(tempOp,itList->second));
					break;
				}
			}
		}
		retList.swap(tempList);
	}

	return retList;
}

//// friend function implementation ////
istream& operator>>(istream &o, SpinOperatorsOnSitesXYBasis &s){
	// Input
	// This function reads an Single Operator in the Form Sx*Sx (almost the same as in in SpinOperators.h, see kaneMeleHubbardToSpinDerivator)
	// IMPORTANT: If no sites are specified the Sites are just set to 0,1,2,3,... and must be set to the correct sites using the assignSites-Method!
	// 28.08.2014: now this function also works with specified sites (e.g. Sx0*Sx2)
	// 02.09.2014: this is a simpler version of SpinOperatorsOnSites without the template! Therefore the Prefactor is NOT read in by this routine! ONLY THE OPERATORS!!!
	char tempChar=0;

	s.operatorSequence.clear();

	unsigned short siteIndex=0;
	while(o.peek()=='*'){
		o>>tempChar;
		o>>tempChar;
		//identify operator
		char opChar=0;
		//cout << "tempChar=" << tempChar << "\n";
		if(tempChar=='E'){
			opChar='E';
		}
		else{
			if(tempChar=='S'){
				o>>tempChar;
				switch(tempChar){
					case 'x':{
						opChar='x';
						break;
					}
					case 'y':{
						opChar='y';
						break;
					}
					case 'z':{
						opChar='z';
						break;
					}
				}
			}
		}
		// check if a site is already defined
		unsigned short x;
		if(o>>x){
			s.operatorSequence.push_back(pair<unsigned short,char>(x,opChar));
		}
		else{
			o.clear();
			s.operatorSequence.push_back(pair<unsigned short,char>(siteIndex,opChar));
			siteIndex++;
		}
	}


	if(s.operatorSequence.size()==0){
		o.setstate(ios_base::failbit);
		//cout << "Leaving with failbit ..." << endl;
	}
	else{
		o.clear();
	}

	return o;
}

ostream& operator<<(ostream &o, SpinOperatorsOnSitesXYBasis &s){
	for(unsigned int i=0;i<s.operatorSequence.size();i++){
		if(i!=0){
			o << "*";
		}
		if(s.operatorSequence[i].second=='E'){
			o << "E";
		}
		else{
			if(s.operatorSequence[i].second=='x'){
				o << "Sx";
			}
			else{
				if(s.operatorSequence[i].second=='y'){
					o << "Sy";
				}
				else{
					if(s.operatorSequence[i].second=='z'){
						o << "Sz";
					}
				}
			}
		}
		o << s.operatorSequence[i].first;
	}
	return o;
}
