// define global variables for use in the whole program

#ifndef GLOBALVARIABLES_H_
#define GLOBALVARIABLES_H_

#include "nr3.h"

using namespace std;

// this defines the length of the states
typedef unsigned long int stateInt;

// for certain repMethods the sublattice states are used as the states of the complete system
typedef unsigned long int subStateInt;

extern Doub zeroEPS; // Definition for zero in floating point operations

const unsigned int numberOfThreads=4; // number of threads for openmp support within the application of H

extern subStateInt localHilbertSpace; // number of bits which are needed to represent the local hilbert space of a single site (will be determined automatically from the total spin of a single site)
extern unsigned int numberOfSites; // number of sites of the system (needed by many functions, therefore globally defined)
extern int totalS; // total spin (times 2) of a single site (needed by many functions, therefore globally defined)




#endif /* GLOBALVARIABLES_H_ */
